if(isFile("Add-Ons/System_ReturnToBlockland/server.cs"))
{
	if(!$RTB::RTBR_ServerControl_Hook)
	{
		exec("Add-Ons/System_ReturnToBlockland/RTBR_ServerControl_Hook.cs");
	}
	
	// Description, ModName, Variable, Properties, Mod, Default value, Requires Restart, Super-Admin Only
	RTB_registerPref("Jet to Cloak", "Invisibility Watches Set", "$CloakWatches::JetTrigger", "bool", "Item_InvisibilityWatch", 1, 0, 0);
}
else
{
	$CloakWatches::JetTrigger = 1;
}

package CloakingPlayers
{
   function Armor::onDisabled(%this,%player)
   {
      if(%player.isCloaked || %player.isCloaking)
      {
         if(!%player.isCloaking)
            serverplay3d(%player.cloakWatch.uncloakSound,%player.getPosition());
         
         %player.unHideNode("ALL");
         
         if(isObject(%player.client))
         {
            %player.client.applyBodyParts();
            %player.client.applyBodyColors();
         }
         else
            applyDefaultCharacterPrefs(%player);
         
         %player.isCloaked = 0;
         %player.isCloaking = 0;
         cancel(%player.cloakAnimSched);
         cancel(%player.cloakSched);
      }
      Parent::onDisabled(%this,%player);
   }
   function Armor::onDamage(%this,%player,%amt)
   {
      Parent::onDamage(%this,%player,%amt);
      if(%player.getState() !$= "Dead" && %player.isCloaked && !%player.isCloaking && %player.cloakWatch.cloakDamageFlicker)
      {
         if(isObject(%player.client))
         {
            if(isObject(%player.client.minigame) && %player.client.tdmTeam != -1 && %player.client.tdmTeam !$= "")
               %col = getColorIDTable(%player.client.minigame.teamCol[%player.client.tdmTeam]);
            else
               %col = %player.client.chestColor;
         }
         else
            %col = "1 1 1 1";
         
         %player.unHideNode("ALL");
         
         if(isObject(%player.client))
         {
            %player.client.applyBodyParts();
            %player.client.applyBodyColors();
         }
         else
            applyDefaultCharacterPrefs(%player); 
         
         %player.setNodeColor("ALL",getWords(%col,0,2) SPC 0.5);
         %player.cloakAnimSched = %player.schedule(300,hideNode,"ALL");
      }
   }
   
   function ShapeBase::damage(%this, %sourceObject, %pos, %directDamage, %damageType)
   {
      %type = %this.getType();
      %val = Parent::damage(%this, %sourceObject, %pos, %directDamage, %damageType);
      if(!(%type & $TypeMasks::PlayerObjectType) || %this.getState() !$= "Dead")
         return %val;
      
      if(!isObject(%sourceObject.client.player))
         return %val;
      
      %obj = %sourceObject.client.player;
      %en1 = %obj.cloakEnergy;
      for(%i=0;%i<%obj.dataBlock.maxTools;%i++)
      {
         if(%obj.tool[%i].image.cloakKillRegen > 0)
         {
            if(%obj.lastUnCloakTime > 0)
            {
               %obj.cloakEnergy = %obj.cloakEnergy + 20*%obj.tool[%i].image.cloakChargeRate*(getSimTime()-%obj.lastUnCloakTime)/1000;
               %obj.lastUnCloakTime = getSimTime();
            }
            if(%obj.cloakEnergy + %obj.tool[%i].image.cloakKillRegen < 100)
               %obj.cloakEnergy = %obj.cloakEnergy + %obj.tool[%i].image.cloakKillRegen;
            else
               %obj.cloakEnergy = 100;
            %added = 1;
         }
      }
      if(isObject(%obj.client) && %added)
      {
         %a = %en1;
         %b = %obj.cloakEnergy;
         %c = 100;
         %end1 = (%a / %c) * 25;
         %end2 = (%b / %c) * 25;
         %start = "<color:FFFFFF>";
         %sep1 = "<color:00FF00>";
         %sep2 = "<color:111111>";
         %done1 = (%end1 == 0);
         %done2 = (%end2 == 0);
         if(%done2)
            %str = %sep2;
         else if(%done1)
            %str = %sep1;
         else
            %str = %start;
         
         for(%i=0;%i<25;%i++)
         {
            if(%i > %end1 && !%done1)
            {
               %str = %str @ %sep1;
               %done1 = 1;
            }
            if(%i > %end2 && !%done2)
            {
               %str = %str @ %sep2;
               %done2 = 1;
            }
            %str = %str @ "|";
         }
         bottomprint(%obj.client, "<just:center>" @ %str, 2, 1);
      }
      return %val;
   }
   
   function ctfFlagItem::onPickup(%this,%obj,%player,%amt)
   {
      if(%player.isCloaked || %player.isCloaking)
      {
         if(isObject(%player.client))
            %player.client.centerPrint("\c5You cannot pick up the \c3Flag\c5 while \c3Cloaked\c5!",2);
         return;
      }
      Parent::onPickup(%this,%obj,%player,%amt);
   }
   
   function ShapeBase::setShapeNameDistance(%this,%d)
   {
      //minimum possible
      if(%this.getType() & $TypeMasks::PlayerObjectType && %this.isCloaked)
         %d = 10;
      Parent::setShapeNameDistance(%this,%d);
   }
   
   function Player::clearTempColor(%this)
   {
      if(%this.isCloaked || %this.isCloaking)
         return;
      
      Parent::clearTempColor(%this);
   }
   
   function Player::emote(%this,%type,%skipSpamProtect)
   {
      if(%this.isCloaked && %this.cloakWatch.cloakDamageFlicker == 0)
         return;
      
      Parent::emote(%this,%type,%skipSpamProtect);
   }
   
   function armor::onTrigger(%this,%obj,%slot,%val)
   {
      if(%slot == 0 && %val && %obj.getMountedImage(0).isCloakWatch && !%obj.getMountedImage(0).disableCloakActivate)
      {
         %obj.activateStuff();
      }
      if(%slot == 4 && isObject(%obj.client) && $CloakWatches::JetTrigger)
      {
         if(%val)
            %obj.cloakTriggerTime = getSimTime();
         else if(getSimTime() - %obj.cloakTriggerTime < 500)
         {
            if(%obj.getMountedImage(0).isCloakWatch)
               servercmdUnUseTool(%obj.client);
            else
            {
               %obj.cloakTriggerTime = "";
               for(%i=0;%i<%obj.dataBlock.maxTools;%i++)
                  if(%obj.tool[%i].image.isCloakWatch)
                     servercmdUseTool(%obj.client,%i);
            }
         }
      }
      return Parent::onTrigger(%this,%obj,%slot,%val);
   }
};activatePackage(CloakingPlayers);

function Player::beginCloak(%player,%watch)
{
   if(%player.isCloaked || %player.isCloaking)
      return;
   
   if(%player.getState() $= "Dead")
      return;
   
   %player.isCloaking = 1;
   %player.cloakWatch = %watch.getID();
   
   //%player.cloakSched = %player.schedule((100 / (32 * %watch.cloakEnergyDrain))  * ((%player.getEnergyLevel()/100) / (%player.dataBlock.maxEnergy/100)) * 1000,endCloak,%player,%watch);
   //%player.setRechargeRate(-%watch.cloakEnergyDrain * (%player.dataBlock.maxEnergy/100));
   
   %player.playAudio(0,%watch.cloakSound);
   %player.doCloakAnimation(1,0);
   %player.isUncloaking = 0;
   %player.setImageAmmo(0,1);
}

function Player::endCloak(%player)
{
   if(!%player.isCloaked || %player.isCloaking)
      return;
   
   if(%player.getState() $= "Dead")
      return;
   
   %player.playAudio(0,%player.cloakWatch.uncloakSound);
   
   %player.unHideNode("ALL");
   
   if(isObject(%player.client))
   {
      %player.client.applyBodyParts();
      %player.client.applyBodyColors();
   }
   else
      applyDefaultCharacterPrefs(%player); 

   %player.setNodeColor("ALL","0 0 0 0");
   %player.doCloakAnimation(0,0);
   %player.isUncloaking = 1;
   %player.isCloaked = 0;
   %player.isCloaking = 1;
   //%player.setRechargeRate(0);
   
   %player.setImageAmmo(0,0);
   
   if(isEventPending(%player.cloakSched))
      cancel(%player.cloakSched);
}

function Player::doCloakAnimation(%player,%direction,%amt)
{
   if(%player.getState() $= "Dead")
   {
      cancel(%player.cloakAnimSched);
      return;
   }
   
   if(isObject(%player.client))
   {
      if(isObject(%player.client.minigame) && %player.client.tdmTeam != -1 && %player.client.tdmTeam !$= "")
         %col = getColorIDTable(%player.client.minigame.teamCol[%player.client.tdmTeam]);
      else
         %col = %player.client.chestColor;
   }
   else
      %col = "1 1 1 1";
   
   %amt+=0.1;
   if(%direction == 1)
   {
      %player.setNodeColor("ALL",getWords(%col,0,2) SPC (1-%amt)/2);
      if(%amt >= 1)
      {
         %player.isCloaking = 0;
         %player.isCloaked = 1;
         %player.hideNode("ALL");
         %player.setShapeNameDistance(10);
         if(!isObject(%player.tool[%player.currTool].image) || (%player.tool[%player.currTool].image.getID() != %player.cloakWatch))
            %player.endCloak();
         return;
      }
   }
   else
   {
      %player.setNodeColor("ALL",getWords(%col,0,2) SPC %amt/2);
      if(%amt >= 1)
      {
         %player.isCloaking = 0;
         %player.isCloaked = 0;
         %player.lastUnCloakTime = getSimTime();
         
         if(isObject(%player.client))
         {
            %player.client.applyBodyColors();
            if(%player.getMountedImage(0) == %player.cloakWatch)
               if(%player.currTool != -1)
                  servercmdUseTool(%player.client,%player.currTool);
               else
                  %player.unMountImage(0);
         }
         else
            applyDefaultCharacterPrefs(%player);
         
         if(fileName(%player.dataBlock.shapeFile) $= "m.dts")
            %player.unHideNode("headSkin");
         
         //if(%player.dataBlock.rechargeRate != PlayerStandardArmor.rechargeRate && %player.dataBlock.rechargeRate != 0)
         //   %player.setRechargeRate(%player.dataBlock.rechargeRate);
         //else
         //   %player.setRechargeRate(%player.cloakWatch.item.rechargeRate * (%player.dataBlock.maxEnergy/100));
         
         %player.setShapeNameDistance(600);
         
         return;
      }
   }
   %player.cloakAnimSched = %player.schedule(100,doCloakAnimation,%direction,%amt);
}