//////////////////////////////////////////////////////////////////////////////////////////////////
//				Support_StoredVariable.cs					//
//Creator: Space Guy [ID 130]									//
//												//
//Set the "variableStore" field to store a variable in the item when thrown away.		//
//Set the "variableInitial" field to set the starting value of the variable on pickup.		//
//Set the "variableReplace" field to 1 for it to replace any other item with that variable.	//
//////////////////////////////////////////////////////////////////////////////////////////////////

package StoredVariable
{
	function Player::pickup(%this,%item)
	{
		%data = %item.dataBlock;
		%stored = %item.variableStored;
		
		if(%data.variableReplace && miniGameCanUse(%this,%item))
		{
			for(%i=0;%i<%this.dataBlock.maxTools;%i++)
			{
				if(%this.tool[%i].variableReplace && %this.tool[%i].variableStore $= %data.variableStore)
				{
					%this.tool[%i] = 0;
					if(isObject(%this.client))
						messageClient(%this.client,'MsgItemPickup',"",%i,0);
					if(%this.currTool == %i)
						servercmdUnusetool(%this.client);
				}
			}
		}
		
		%val = Parent::pickup(%this,%item);
		if(%val == 1)
		{
			if(%stored !$= "")
				eval(%this @ "." @ %data.variableStore @ " = " @ %stored @ ";");	
			else if(%data.variableStore !$= "")
				eval(%this @ "." @ %data.variableStore @ " = " @ %data.variableInitial @ ";");	
		}
		return %val;
	}
	
	function servercmdDropTool(%client,%slot)
	{
		if(isObject(%client.player))
		{
			if(%client.player.tool[%slot].variableStore !$= "")
				eval("$variableStored = " @ %client.player @ "." @ %client.player.tool[%slot].variableStore @ ";");
		}
		
		Parent::servercmdDropTool(%client,%slot);
	}
	
	function ItemData::onAdd(%this,%obj)
	{
		if($variableStored !$= "")
		{
			%obj.variableStored = $variableStored;
			$variableStored = "";
		}
		Parent::onAdd(%this,%obj);
	}
	
	function GameConnection::createPlayer(%this,%transform)
	{
		Parent::createPlayer(%this,%transform);
		
		if(!isObject(%this.player))
			return;
		
		for(%i=0;%i<%this.player.dataBlock.maxTools;%i++)
		{
			%item = %this.player.tool[%i];
			
			if(%item.variableInitial !$= "")
				eval(%this.player @ "." @ %item.variableStore @ " = " @ %item.variableInitial @ ";");	
			
			if(%item.variableReplace == 1)
			{
				if(%hasItem[%item.variableStore])
				{
					%this.player.tool[%i] = 0;
					messageClient(%this,'MsgItemPickup',"",%i,0);
				}
				else
					%hasItem[%item.variableStore] = 1;
			}
		}
	}
	
	function servercmdSetMinigameData(%client,%datastring)
	{
			Parent::servercmdSetMinigameData(%client,%datastring);
			if(!isObject(%client.minigame) || %client.minigame.owner != %client)
				return;
			
			for(%i=0;%i<%client.minigame.numMembers;%i++)
			{
				%cl = %client.minigame.member[%i];
				if(isObject(%cl.player))
				{
					for(%j=0;%j<%cl.player.dataBlock.maxTools;%j++)
					{
						%item = %cl.player.tool[%j];
						
						if(%item.energyDrainOnPickup)
								eval(%this.player @ "." @ %item.variableStore @ " = " @ %item.variableInitial @ ";");	
						
						if(%item.variableReplace == 1)
						{
							if(%hasItem[%cl,%item.variableStore])
							{
								%cl.player.tool[%i] = 0;
								messageClient(%cl,'MsgItemPickup',"",%i,0);
								if(%cl.player.currTool == %j)
									servercmdUnusetool(%cl);
							}
							else
								%hasItem[%cl,%item.variableStore] = 1;
						}
					}
				}
			}
	}
	
	function servercmdProcessGameModeData(%client)
	{
			Parent::servercmdProcessGameModeData(%client);
			if(!isObject(%client.minigame) || %client.minigame.owner != %client)
				return;
			
			for(%i=0;%i<%client.minigame.numMembers;%i++)
			{
				%cl = %client.minigame.member[%i];
				if(isObject(%cl.player))
				{
					for(%j=0;%j<%cl.player.dataBlock.maxTools;%j++)
					{
						%item = %cl.player.tool[%j];
						
						if(%item.energyDrainOnPickup)
								eval(%this.player @ "." @ %item.variableStore @ " = " @ %item.variableInitial @ ";");	
						
						if(%item.variableReplace == 1)
						{
							if(%hasItem[%cl,%item.variableStore])
							{
								%cl.player.tool[%i] = 0;
								messageClient(%cl,'MsgItemPickup',"",%i,0);
								if(%cl.player.currTool == %j)
									servercmdUnusetool(%cl);
							}
							else
								%hasItem[%cl,%item.variableStore] = 1;
						}
					}
				}
			}
	}
};schedule(100,0,activatePackage,StoredVariable);